2014-04-15 09:47:41 +00:00
#! @shell@
2014-04-18 14:05:20 +00:00
if [ -x "@shell@" ] ; then export SHELL = "@shell@" ; fi ;
2014-04-15 09:47:41 +00:00
set -e
2007-02-06 13:09:25 +00:00
2007-02-06 13:12:10 +00:00
showSyntax( ) {
2013-10-11 12:05:53 +00:00
exec man nixos-rebuild
2007-02-06 13:09:25 +00:00
exit 1
2007-02-06 13:12:10 +00:00
}
2008-08-04 14:58:26 +00:00
# Parse the command line.
2014-04-15 09:47:41 +00:00
origArgs = ( " $@ " )
2012-11-22 11:04:00 +00:00
extraBuildFlags = ( )
2008-08-04 14:58:26 +00:00
action =
2009-08-03 12:36:15 +00:00
buildNix = 1
2017-02-11 13:52:23 +00:00
fast =
2009-08-19 15:04:19 +00:00
rollback =
2012-06-25 20:17:34 +00:00
upgrade =
2013-07-23 18:31:03 +00:00
repair =
2013-10-09 17:13:26 +00:00
profile = /nix/var/nix/profiles/system
2016-01-11 18:41:48 +00:00
buildHost =
targetHost =
2008-08-04 14:58:26 +00:00
2013-01-16 12:21:59 +00:00
while [ " $# " -gt 0 ] ; do
2009-08-03 12:36:15 +00:00
i = " $1 " ; shift 1
2010-01-03 13:36:23 +00:00
case " $i " in
--help)
2008-08-04 14:58:26 +00:00
showSyntax
2012-06-25 20:17:34 +00:00
; ;
2019-02-24 23:59:35 +00:00
switch| boot| test| build| edit| dry-build| dry-run| dry-activate| build-vm| build-vm-with-bootloader)
2015-03-09 15:23:23 +00:00
if [ " $i " = dry-run ] ; then i = dry-build; fi
2008-08-04 14:58:26 +00:00
action = " $i "
2012-06-25 20:17:34 +00:00
; ;
2010-01-03 13:36:23 +00:00
--install-grub)
2016-08-16 11:51:58 +00:00
echo " $0 : --install-grub deprecated, use --install-bootloader instead " >& 2
export NIXOS_INSTALL_BOOTLOADER = 1
; ;
--install-bootloader)
export NIXOS_INSTALL_BOOTLOADER = 1
2012-06-25 20:17:34 +00:00
; ;
2010-01-03 13:36:23 +00:00
--no-build-nix)
2009-08-03 12:36:15 +00:00
buildNix =
2012-06-25 20:17:34 +00:00
; ;
2010-01-03 13:36:23 +00:00
--rollback)
2009-08-19 15:04:19 +00:00
rollback = 1
2012-06-25 20:17:34 +00:00
; ;
--upgrade)
upgrade = 1
; ;
2013-07-23 18:31:03 +00:00
--repair)
repair = 1
extraBuildFlags += ( " $i " )
; ;
2019-01-11 10:39:26 +00:00
--max-jobs| -j| --cores| -I| --builders)
2011-03-07 12:12:39 +00:00
j = " $1 " ; shift 1
2012-11-22 11:04:00 +00:00
extraBuildFlags += ( " $i " " $j " )
2012-06-25 20:17:34 +00:00
; ;
2019-01-11 10:39:26 +00:00
--show-trace| --keep-failed| -K| --keep-going| -k| --verbose| -v| -vv| -vvv| -vvvv| -vvvvv| --fallback| --repair| --no-build-output| -Q| -j*)
2017-02-11 12:18:17 +00:00
extraBuildFlags += ( " $i " )
; ;
2012-09-14 17:23:19 +00:00
--option)
j = " $1 " ; shift 1
k = " $1 " ; shift 1
2012-11-22 11:04:00 +00:00
extraBuildFlags += ( " $i " " $j " " $k " )
2012-09-14 17:23:19 +00:00
; ;
2010-01-03 13:36:23 +00:00
--fast)
2009-10-14 23:56:11 +00:00
buildNix =
2017-02-11 13:52:23 +00:00
fast = 1
2012-11-22 11:04:00 +00:00
extraBuildFlags += ( --show-trace)
2012-06-25 20:17:34 +00:00
; ;
2013-10-09 17:13:26 +00:00
--profile-name| -p)
if [ -z " $1 " ] ; then
echo " $0 : ‘ --profile-name’ requires an argument "
exit 1
fi
if [ " $1 " != system ] ; then
profile = " /nix/var/nix/profiles/system-profiles/ $1 "
mkdir -p -m 0755 " $( dirname " $profile " ) "
fi
shift 1
; ;
2016-01-11 18:41:48 +00:00
--build-host| h)
buildHost = " $1 "
shift 1
; ;
--target-host| t)
targetHost = " $1 "
shift 1
; ;
2010-01-03 13:36:23 +00:00
*)
2008-08-04 14:58:26 +00:00
echo " $0 : unknown option \` $i ' "
exit 1
2012-06-25 20:17:34 +00:00
; ;
2010-01-03 13:36:23 +00:00
esac
2008-08-04 14:58:26 +00:00
done
2016-01-11 18:41:48 +00:00
if [ -z " $buildHost " -a -n " $targetHost " ] ; then
buildHost = " $targetHost "
fi
if [ " $targetHost " = localhost ] ; then
targetHost =
fi
if [ " $buildHost " = localhost ] ; then
buildHost =
fi
buildHostCmd( ) {
if [ -z " $buildHost " ] ; then
" $@ "
elif [ -n " $remoteNix " ] ; then
ssh $SSHOPTS " $buildHost " PATH = " $remoteNix : $PATH " " $@ "
else
ssh $SSHOPTS " $buildHost " " $@ "
fi
}
targetHostCmd( ) {
if [ -z " $targetHost " ] ; then
" $@ "
else
ssh $SSHOPTS " $targetHost " " $@ "
fi
}
copyToTarget( ) {
if ! [ " $targetHost " = " $buildHost " ] ; then
if [ -z " $targetHost " ] ; then
2016-12-18 21:39:27 +00:00
NIX_SSHOPTS = $SSHOPTS nix-copy-closure --from " $buildHost " " $1 "
2016-01-11 18:41:48 +00:00
elif [ -z " $buildHost " ] ; then
2016-12-18 21:39:27 +00:00
NIX_SSHOPTS = $SSHOPTS nix-copy-closure --to " $targetHost " " $1 "
2016-01-11 18:41:48 +00:00
else
buildHostCmd nix-copy-closure --to " $targetHost " " $1 "
fi
fi
}
nixBuild( ) {
if [ -z " $buildHost " ] ; then
nix-build " $@ "
else
local instArgs = ( )
local buildArgs = ( )
while [ " $# " -gt 0 ] ; do
local i = " $1 " ; shift 1
case " $i " in
-o)
local out = " $1 " ; shift 1
buildArgs += ( "--add-root" " $out " "--indirect" )
; ;
-A)
local j = " $1 " ; shift 1
instArgs += ( " $i " " $j " )
; ;
2016-02-01 09:54:58 +00:00
-I) # We don't want this in buildArgs
2016-01-11 18:41:48 +00:00
shift 1
; ;
2016-02-01 09:54:58 +00:00
--no-out-link) # We don't want this in buildArgs
; ;
2016-01-11 18:41:48 +00:00
"<" *) # nix paths
instArgs += ( " $i " )
; ;
*)
buildArgs += ( " $i " )
; ;
esac
done
local drv = " $( nix-instantiate " ${ instArgs [@] } " " ${ extraBuildFlags [@] } " ) "
if [ -a " $drv " ] ; then
2016-12-18 21:39:27 +00:00
NIX_SSHOPTS = $SSHOPTS nix-copy-closure --to " $buildHost " " $drv "
2016-01-11 18:41:48 +00:00
buildHostCmd nix-store -r " $drv " " ${ buildArgs [@] } "
else
echo "nix-instantiate failed"
exit 1
fi
fi
}
2013-01-16 12:21:59 +00:00
if [ -z " $action " ] ; then showSyntax; fi
2007-02-06 13:09:25 +00:00
2014-04-15 09:47:41 +00:00
# Only run shell scripts from the Nixpkgs tree if the action is
# "switch", "boot", or "test". With other actions (such as "build"),
# the user may reasonably expect that no code from the Nixpkgs tree is
# executed, so it's safe to run nixos-rebuild against a potentially
# untrusted tree.
canRun =
if [ " $action " = switch -o " $action " = boot -o " $action " = test ] ; then
canRun = 1
fi
2015-04-13 10:41:31 +00:00
# If ‘ --upgrade’ is given, run ‘ nix-channel --update nixos’ .
2014-04-15 09:47:41 +00:00
if [ -n " $upgrade " -a -z " $_NIXOS_REBUILD_REEXEC " ] ; then
2015-04-13 10:41:31 +00:00
nix-channel --update nixos
# If there are other channels that contain a file called
# ".update-on-nixos-rebuild", update them as well.
for channelpath in /nix/var/nix/profiles/per-user/root/channels/*; do
if [ -e " $channelpath /.update-on-nixos-rebuild " ] ; then
nix-channel --update " $( basename " $channelpath " ) "
fi
done
2014-04-15 09:47:41 +00:00
fi
2014-06-10 18:09:48 +00:00
# Make sure that we use the Nix package we depend on, not something
# else from the PATH for nix-{env,instantiate,build}. This is
# important, because NixOS defaults the architecture of the rebuilt
# system to the architecture of the nix-* binaries used. So if on an
# amd64 system the user has an i686 Nix package in her PATH, then we
# would silently downgrade the whole system to be i686 NixOS on the
# next reboot.
if [ -z " $_NIXOS_REBUILD_REEXEC " ] ; then
export PATH = @nix@/bin:$PATH
fi
2014-04-15 09:47:41 +00:00
# Re-execute nixos-rebuild from the Nixpkgs tree.
2017-02-11 13:52:23 +00:00
if [ -z " $_NIXOS_REBUILD_REEXEC " -a -n " $canRun " -a -z " $fast " ] ; then
2016-08-07 00:17:41 +00:00
if p = $( nix-build --no-out-link --expr 'with import <nixpkgs/nixos> {}; config.system.build.nixos-rebuild' " ${ extraBuildFlags [@] } " ) ; then
2014-04-15 09:47:41 +00:00
export _NIXOS_REBUILD_REEXEC = 1
2016-08-07 00:17:41 +00:00
exec $p /bin/nixos-rebuild " ${ origArgs [@] } "
2014-04-15 09:47:41 +00:00
exit 1
fi
2009-08-19 15:04:19 +00:00
fi
2019-02-24 23:59:35 +00:00
# Find configuration.nix and open editor instead of building.
if [ " $action " = edit ] ; then
NIXOS_CONFIG = ${ NIXOS_CONFIG :- $( nix-instantiate --find-file nixos-config) }
exec " ${ EDITOR :- nano } " " $NIXOS_CONFIG "
exit 1
fi
2007-02-06 13:09:25 +00:00
2009-08-03 12:44:45 +00:00
tmpDir = $( mktemp -t -d nixos-rebuild.XXXXXX)
2016-01-11 18:41:48 +00:00
SSHOPTS = " $NIX_SSHOPTS -o ControlMaster=auto -o ControlPath= $tmpDir /ssh-%n -o ControlPersist=60 "
cleanup( ) {
for ctrl in " $tmpDir " /ssh-*; do
ssh -o ControlPath = " $ctrl " -O exit dummyhost 2>/dev/null || true
done
rm -rf " $tmpDir "
}
trap cleanup EXIT
2009-08-03 12:44:45 +00:00
2008-06-04 09:01:54 +00:00
# If the Nix daemon is running, then use it. This allows us to use
# the latest Nix from Nixpkgs (below) for expression evaluation, while
# still using the old Nix (via the daemon) for actual store access.
# This matters if the new Nix in Nixpkgs has a schema change. It
# would upgrade the schema, which should only happen once we actually
# switch to the new configuration.
2013-07-23 18:31:03 +00:00
# If --repair is given, don't try to use the Nix daemon, because the
# flag can only be used directly.
if [ -z " $repair " ] && systemctl show nix-daemon.socket nix-daemon.service | grep -q ActiveState = active; then
2017-07-07 09:57:00 +00:00
export NIX_REMOTE = ${ NIX_REMOTE -daemon }
2008-06-04 09:01:54 +00:00
fi
2007-09-18 15:38:05 +00:00
# First build Nix, since NixOS may require a newer version than the
2014-04-15 10:03:30 +00:00
# current one.
2015-03-09 15:23:23 +00:00
if [ -n " $rollback " -o " $action " = dry-build ] ; then
2014-04-15 09:47:41 +00:00
buildNix =
fi
2019-02-21 01:02:20 +00:00
nixSystem( ) {
machine = " $( uname -m) "
if [ [ " $machine " = ~ i.86 ] ] ; then
machine = i686
fi
echo $machine -linux
}
2016-01-11 18:41:48 +00:00
prebuiltNix( ) {
machine = " $1 "
if [ " $machine " = x86_64 ] ; then
2016-09-06 14:07:24 +00:00
echo @nix_x86_64_linux@
2016-01-11 18:41:48 +00:00
elif [ [ " $machine " = ~ i.86 ] ] ; then
2016-09-06 14:07:24 +00:00
echo @nix_i686_linux@
2016-01-11 18:41:48 +00:00
else
echo " $0 : unsupported platform "
exit 1
fi
}
remotePATH =
2014-04-15 09:47:41 +00:00
if [ -n " $buildNix " ] ; then
2009-12-09 18:23:48 +00:00
echo "building Nix..." >& 2
2016-01-11 18:41:48 +00:00
nixDrv =
2016-04-24 11:06:04 +00:00
if ! nixDrv = " $( nix-instantiate '<nixpkgs/nixos>' --add-root $tmpDir /nix.drv --indirect -A config.nix.package.out " ${ extraBuildFlags [@] } " ) " ; then
2017-03-06 14:53:34 +00:00
if ! nixDrv = " $( nix-instantiate '<nixpkgs>' --add-root $tmpDir /nix.drv --indirect -A nix " ${ extraBuildFlags [@] } " ) " ; then
2019-02-21 01:02:20 +00:00
if ! nixStorePath = " $( nix-instantiate --eval '<nixpkgs/nixos/modules/installer/tools/nix-fallback-paths.nix>' -A $( nixSystem) | sed -e 's/^"//' -e 's/"$//' ) " ; then
nixStorePath = " $( prebuiltNix " $( uname -m) " ) "
fi
2017-03-06 14:53:34 +00:00
if ! nix-store -r $nixStorePath --add-root $tmpDir /nix --indirect \
--option extra-binary-caches https://cache.nixos.org/; then
echo "warning: don't know how to get latest Nix" >& 2
fi
# Older version of nix-store -r don't support --add-root.
[ -e $tmpDir /nix ] || ln -sf $nixStorePath $tmpDir /nix
if [ -n " $buildHost " ] ; then
remoteNixStorePath = " $( prebuiltNix " $( buildHostCmd uname -m) " ) "
remoteNix = " $remoteNixStorePath /bin "
if ! buildHostCmd nix-store -r $remoteNixStorePath \
--option extra-binary-caches https://cache.nixos.org/ >/dev/null; then
remoteNix =
2014-04-15 10:03:30 +00:00
echo "warning: don't know how to get latest Nix" >& 2
fi
fi
2010-03-04 14:38:53 +00:00
fi
2008-03-13 10:17:42 +00:00
fi
2016-01-11 18:41:48 +00:00
if [ -a " $nixDrv " ] ; then
2016-01-11 18:43:05 +00:00
nix-store -r " $nixDrv " '!' "out" --add-root $tmpDir /nix --indirect >/dev/null
2016-01-11 18:41:48 +00:00
if [ -n " $buildHost " ] ; then
nix-copy-closure --to " $buildHost " " $nixDrv "
# The nix build produces multiple outputs, we add them all to the remote path
for p in $( buildHostCmd nix-store -r " $( readlink " $nixDrv " ) " " ${ buildArgs [@] } " ) ; do
remoteNix = " $remoteNix ${ remoteNix : + : } $p /bin "
done
fi
fi
PATH = " $tmpDir /nix/bin: $PATH "
2008-01-02 15:30:31 +00:00
fi
2007-09-18 15:38:05 +00:00
2013-01-16 13:40:41 +00:00
# Update the version suffix if we're building from Git (so that
# nixos-version shows something useful).
2014-04-15 09:47:41 +00:00
if [ -n " $canRun " ] ; then
if nixpkgs = $( nix-instantiate --find-file nixpkgs " ${ extraBuildFlags [@] } " ) ; then
2016-08-09 12:11:29 +00:00
suffix = $( $SHELL $nixpkgs /nixos/modules/installer/tools/get-version-suffix " ${ extraBuildFlags [@] } " || true )
if [ -n " $suffix " ] ; then
echo -n " $suffix " > " $nixpkgs /.version-suffix " || true
2014-04-15 09:47:41 +00:00
fi
2013-01-16 13:40:41 +00:00
fi
fi
2015-03-09 15:23:23 +00:00
if [ " $action " = dry-build ] ; then
2013-01-16 15:11:51 +00:00
extraBuildFlags += ( --dry-run)
fi
2007-02-06 13:09:25 +00:00
# Either upgrade the configuration in the system profile (for "switch"
# or "boot"), or just build it and create a symlink "result" in the
# current directory (for "build" and "test").
2013-01-16 12:21:59 +00:00
if [ -z " $rollback " ] ; then
2009-12-09 18:23:48 +00:00
echo "building the system configuration..." >& 2
2013-01-16 12:21:59 +00:00
if [ " $action " = switch -o " $action " = boot ] ; then
2016-02-01 09:37:41 +00:00
pathToConfig = " $( nixBuild '<nixpkgs/nixos>' --no-out-link -A system " ${ extraBuildFlags [@] } " ) "
2016-01-11 18:41:48 +00:00
copyToTarget " $pathToConfig "
targetHostCmd nix-env -p " $profile " --set " $pathToConfig "
2015-03-09 15:23:23 +00:00
elif [ " $action " = test -o " $action " = build -o " $action " = dry-build -o " $action " = dry-activate ] ; then
2016-01-11 18:41:48 +00:00
pathToConfig = " $( nixBuild '<nixpkgs/nixos>' -A system -k " ${ extraBuildFlags [@] } " ) "
2010-09-13 12:34:58 +00:00
elif [ " $action " = build-vm ] ; then
2016-01-11 18:41:48 +00:00
pathToConfig = " $( nixBuild '<nixpkgs/nixos>' -A vm -k " ${ extraBuildFlags [@] } " ) "
2010-09-13 12:34:58 +00:00
elif [ " $action " = build-vm-with-bootloader ] ; then
2016-01-11 18:41:48 +00:00
pathToConfig = " $( nixBuild '<nixpkgs/nixos>' -A vmWithBootLoader -k " ${ extraBuildFlags [@] } " ) "
2009-08-19 15:04:19 +00:00
else
showSyntax
fi
2016-01-11 18:41:48 +00:00
# Copy build to target host if we haven't already done it
if ! [ " $action " = switch -o " $action " = boot ] ; then
copyToTarget " $pathToConfig "
fi
2013-01-16 12:21:59 +00:00
else # [ -n "$rollback" ]
if [ " $action " = switch -o " $action " = boot ] ; then
2016-01-11 18:41:48 +00:00
targetHostCmd nix-env --rollback -p " $profile "
2013-10-09 17:13:26 +00:00
pathToConfig = " $profile "
2013-01-16 12:21:59 +00:00
elif [ " $action " = test -o " $action " = build ] ; then
2009-08-19 15:04:19 +00:00
systemNumber = $(
2016-01-11 18:41:48 +00:00
targetHostCmd nix-env -p " $profile " --list-generations |
2009-08-19 15:04:19 +00:00
sed -n '/current/ {g; p;}; s/ *\([0-9]*\).*/\1/; h'
)
2016-01-11 18:41:48 +00:00
pathToConfig = " $profile " -${ systemNumber } -link
if [ -z " $targetHost " ] ; then
ln -sT " $pathToConfig " ./result
fi
2009-08-19 15:04:19 +00:00
else
showSyntax
fi
2007-02-06 13:09:25 +00:00
fi
# If we're not just building, then make the new configuration the boot
# default and/or activate it now.
2015-03-09 15:23:23 +00:00
if [ " $action " = switch -o " $action " = boot -o " $action " = test -o " $action " = dry-activate ] ; then
2016-01-11 18:41:48 +00:00
if ! targetHostCmd $pathToConfig /bin/switch-to-configuration " $action " ; then
2015-10-25 01:26:49 +00:00
echo "warning: error(s) occurred while switching to the new configuration" >& 2
2014-08-14 23:57:36 +00:00
exit 1
fi
2007-02-06 13:09:25 +00:00
fi
2007-02-06 13:20:53 +00:00
2013-01-16 12:21:59 +00:00
if [ " $action " = build-vm ] ; then
2009-08-11 01:35:56 +00:00
cat >& 2 <<EOF
2018-03-09 08:36:57 +00:00
Done. The virtual machine can be started by running $( echo $pathToConfig /bin/run-*-vm)
2009-08-11 01:35:56 +00:00
EOF
fi